/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.service.impl;

import com.rjconsultores.ventaboletos.dao.RedondeoCtrlDAO;
import com.rjconsultores.ventaboletos.entidad.Redondeo;
import com.rjconsultores.ventaboletos.entidad.RedondeoCtrl;
import com.rjconsultores.ventaboletos.entidad.RedondeoMarca;
import com.rjconsultores.ventaboletos.service.RedondeoCtrlService;
import com.rjconsultores.ventaboletos.utilerias.UsuarioLogado;
import java.math.BigDecimal;
import java.util.Calendar;
import java.util.List;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

/**
 *
 * @author Administrador
 */
@Service("redondeoCtrlService")
public class RedondeoCtrlServiceImpl implements RedondeoCtrlService {

    @Autowired
    private RedondeoCtrlDAO redondeoCtrlDAO;

    public List<RedondeoCtrl> obtenerTodos() {
        return redondeoCtrlDAO.obtenerTodos();
    }

    public RedondeoCtrl obtenerID(Integer id) {
        return redondeoCtrlDAO.obtenerID(id);
    }

    @Transactional
    public RedondeoCtrl suscribir(RedondeoCtrl entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return redondeoCtrlDAO.suscribir(entidad);
    }

    @Transactional
    public RedondeoCtrl actualizacion(RedondeoCtrl entidad) {
        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.TRUE);

        return redondeoCtrlDAO.actualizacion(entidad);
    }

    @Transactional
    public void borrar(RedondeoCtrl entidad) {

        entidad = obtenerID(entidad.getRedondeoctrlId());

        for (Redondeo r : entidad.getRedondeoList()) {
            r.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            r.setFecmodif(Calendar.getInstance().getTime());
            r.setActivo(Boolean.FALSE);
        }
        for (RedondeoMarca rm : entidad.getRedondeoMarcaList()) {
            rm.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
            rm.setFecmodif(Calendar.getInstance().getTime());
            rm.setActivo(Boolean.FALSE);
        }

        entidad.setUsuarioId(UsuarioLogado.getUsuarioLogado().getUsuarioId());
        entidad.setFecmodif(Calendar.getInstance().getTime());
        entidad.setActivo(Boolean.FALSE);

        redondeoCtrlDAO.actualizacion(entidad);
    }

    public List<RedondeoCtrl> buscar(RedondeoCtrl redondeoCtrl) {
        return redondeoCtrlDAO.buscar(redondeoCtrl);
    }

    public List<RedondeoCtrl> buscarTraslapa(Short[] iDMarcas, BigDecimal valorinicial, BigDecimal valorfinal, Boolean indaplicadescuento, 
    		Boolean indaplicapricing, Boolean indaplicaAtersp) {
        return redondeoCtrlDAO.buscarTraslapa(iDMarcas, valorinicial, valorfinal, indaplicadescuento, indaplicapricing, indaplicaAtersp);
    }
}
